

doc ///
    Key
        FThresholds
    Headline
        a package for computing numerical invariants in prime characteristic
    Description
        Text
            The Frobenius endomorphism on a ring of prime characteristic $p$, which sends a ring element to
            its $p$-th power, is a fundamental tool in prime characteristic commutative algebra.
            Kunz has shown that regularity is characterized
            by the behavior of this map, and since then, many other properties of Frobenius have been used to
            measure how {\em far} a ring is from being regular.

            Numerical invariants of rings, and of their elements and ideals, play an
            important role in this endeavor. Of particular focus are the $F$-pure threshold, and more generally,
            $F$-thresholds.

            However, the computation of these numerical invariants
            can be quite subtle, and at the same time computationally complex. In partnership with the package @TO TestIdeals@,
            which provides some important functionality for researchers in positive characteristic
            commutative algebra, the package @TO FThresholds@ implements known algorithms, as well as new methods,
            to estimate and compute numerical invariants in prime characteristic.
    SeeAlso
        TestIdeals
///
